#pragma once

namespace a8
{
    class XObject;
    class MutableXObject;
}

namespace f8
{

    class JsonHttpRequest
    {
    private:
        unsigned long saddr_ = 0;
        std::string url_;
        std::string query_str_;
        std::shared_ptr<a8::XObject> params_;
        std::shared_ptr<a8::MutableXObject> resp_xobj_;
        a8::CommonCbProc cb_;
        bool resped_ = false;

    public:
        JsonHttpRequest(unsigned long saddr,
                        const std::string url,
                        const std::string& query_str,
                        a8::CommonCbProc cb);
        ~JsonHttpRequest();

        const std::string GetUrl() { return this->url_; }
        std::shared_ptr<a8::XObject> GetParams() { return this->params_; }
        std::shared_ptr<a8::MutableXObject> GetResp() { return this->resp_xobj_; }
        void Response();
    };

}
